﻿// StyledListOfStyles[v.3].jsx

/*
Эта программа сделана из идеи, найденной тут:
https://creativepro.com/scripted-style-lists/

Идея -- визуально показать, как выглядит текст, оформленный конкретным абзацным стилем.
Пишется название стиля, оформляется выбранными шрифтом и кеглем. И конечно, работают абзацный отступ, выключка, оступы до и после.

Что изменено:
1) добавлено сообщение, что нет открытого документа.
Я стою на том, что скриптописец не должен гнобить пользователя.
А когда скрипт запускается, и ничего не происходит,то пользователь чувствует себя дураком.
А дело не в нём, а том, кто слепил этот непродуманный код.
Я считаю, что интерефейс без обратной связи на действия пользователя -- это ничем неоправданное неуважение к верстальщикам со стороны скриптоделов.

2) эта программма собирает и отображает информацию о том, в какой группе находится стиль. 
Программное изделие с сайта creativepro.com не заморачивается с этим.

3) В установках абзацного стиля в параметрах удержания может быть включена установка начала абзаца на следующей странице.
Если это так и оставить, то в текущем фрейме строки с названием этого стиля не будет. Но для целей визуализации данная установка не нужна.
Поэтому для всех строк делается "Начать новый абзац: В любом месте".

4) После завершения работы фрейм с визуальной информацией о стилях будет справа от первой страницы документа в масштабе 100%.

https://dotextok.ru

*/
var programTitul = "Визуализация абзацных стилей";
if (app.documents.length == 0) {
aert("Нет открытого документа.",programTitul);
exit();
}
var doc = app.activeDocument;
var psID = [];
var userPS = [];    
var myParagraphStyles = doc.allParagraphStyles;
var myParagraphStyleName, obj;
for (var i=0; i < myParagraphStyles.length ; i++) { // for
    myParagraphStyleName = myParagraphStyles[i].name;
    obj = myParagraphStyles[i];
    while(obj.parent instanceof ParagraphStyleGroup) {
        myParagraphStyleName = obj.parent.name + ":" + myParagraphStyleName;
        obj = obj.parent;        
        }
    userPS.push(myParagraphStyleName);
    psID.push(myParagraphStyles[i].id);
    } // for  
var styleNotFound = true;
for (var i = 0; i < userPS.length; i++) { // i++
    if (userPS[i][0] == "[") continue;
    else {
        styleNotFound = false;
        break;
        }
    } // i++
if (styleNotFound) {    
    alert("В работе нет стилей, созданных пользователем.",programTitul);
    exit();
    }
var page = doc.pages[0];
var bounds = page.bounds;
var theTF = page.textFrames.add({geometricBounds: bounds});
var theStory = theTF.parentStory;
theTF.move(undefined, [bounds[3]-1, 0]); 
for (var j = 0; j < userPS.length; j++) { // j++  
    psName = userPS[j];
    theStory.insertionPoints[-1].contents = psName;
    theStory.paragraphs[-1].appliedParagraphStyle = doc.paragraphStyles.itemByID(psID[j]);
    theStory.paragraphs[-1].startParagraph = StartParagraph.ANYWHERE;
    theStory.insertionPoints[-1].contents = "\r";
    } // j++
app.activeWindow.zoomPercentage = 100;
theTF.texts[0].characters.itemByRange(0,-1).select();
app.activeWindow.activePage = app.selection[0].parentTextFrames[0].parentPage; 
doc.select(NothingEnum.nothing);
app.activate();
exit();



